'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildTypes = undefined;

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

exports.default = function (models, customFields, opt) {
  var typeMap = (0, _type.modelsToTypes)(models);

  var _buildSchema = (0, _schema.buildSchema)(models, typeMap);

  var query = _buildSchema.query;
  var mutation = _buildSchema.mutation;

  var customQuery = customFields && customFields.query;
  var customMutation = customFields && customFields.mutation;
  return new _graphql.GraphQLSchema({
    query: new _graphql.GraphQLObjectType({
      name: 'Query',
      fields: (0, _assign2.default)({}, query, customQuery)
    }),
    mutation: new _graphql.GraphQLObjectType({
      name: 'Mutation',
      fields: (0, _assign2.default)({}, mutation, customMutation)
    })
  });
};

var _graphql = require('graphql');

var _type = require('./type');

var _schema = require('./schema');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var buildTypes = exports.buildTypes = _type.modelsToTypes;