'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _entries = require('babel-runtime/core-js/object/entries');

var _entries2 = _interopRequireDefault(_entries);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.default = function (model, type) {
  var _this = this;

  var modelName = model.modelName;
  var defaultArgs = (0, _buildArgs2.default)(type);
  return (0, _defineProperty3.default)({}, modelName.toLowerCase(), {
    type: new _graphql.GraphQLList(type),
    args: defaultArgs,
    resolve: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_, args) {
        var onlyPlural, query;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!hasRepeateArgs((0, _keys2.default)(args))) {
                  _context.next = 2;
                  break;
                }

                throw new Error('Can not use singular and plural of an argument in same time');

              case 2:
                onlyPlural = void 0;
                query = (0, _entries2.default)(args).map(function (_ref2) {
                  var _ref3 = (0, _slicedToArray3.default)(_ref2, 2);

                  var arg = _ref3[0];
                  var value = _ref3[1];

                  onlyPlural = defaultArgs[arg]['onlyPlural'];
                  arg = arg.replace('_', '.');
                  arg = arg === 'id' && '_id' || arg === 'ids' && '_ids' || arg;
                  if (_pluralize2.default.singular(arg) === arg || onlyPlural) {
                    return (0, _defineProperty3.default)({}, arg, value);
                  } else {
                    return (0, _defineProperty3.default)({}, _pluralize2.default.singular(arg), { $in: value });
                  }
                }).reduce(function (query, item) {
                  return (0, _assign2.default)(query, item);
                }, {});
                _context.next = 6;
                return model.find(query);

              case 6:
                return _context.abrupt('return', _context.sent);

              case 7:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this);
      }));

      return function resolve(_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }()
  });
};

var _graphql = require('graphql');

var _pluralize = require('pluralize');

var _pluralize2 = _interopRequireDefault(_pluralize);

var _buildArgs = require('./buildArgs');

var _buildArgs2 = _interopRequireDefault(_buildArgs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Valid if both singular and plural of a argument were provided
var elem = void 0;

/**
 * Build query for a sigle model
 * @params
 *  - model a mongoose model
 *  - type a corresponding converted graphql type
 * @return
 *  - {Object} e.g. { user: {type: userType, args: {id, ids, userName, userNames...}, resolve} }
 */

var hasRepeateArgs = function hasRepeateArgs(args) {
  if (args.length === 0) return false;
  elem = args.pop();
  if (args.find(function (arg) {
    return arg === _pluralize2.default.plural(elem) || arg === _pluralize2.default.singular(elem);
  })) return true;
  return hasRepeateArgs(args);
};